<template>
    <div>
        <Modal ref="modal1" :title="'Autocomplete'" :fullscreen="'sm'" :size="'xl'" :scrollable="true"
            :verticalCentered="true">

            <AutoComplete v-model="data.selected" :elements="data.elements"
                :initKey="(data.selected != null) ? data.selected.id_example : null" placeholder="Elementos" :minLength="2"
                :disabled="false" :required="true" />

            <template v-slot:footer>
                <button type="button" class="btn btn-primary">Save changes</button>
                <button type="button" class="btn btn-secondary" @click="ocultar1()">Cerrar</button>
            </template>
        </Modal>

        <Modal ref="modal2" :title="'Un titulo'">

            Modal 2

            <!--
                <template v-slot:footer>
                    <button type="button" class="btn btn-primary">Save changes</button>
                </template>
            -->
        </Modal>

        <button @click="mostrar1()">mostrar autocomplete</button><br>
        <button @click="mostrar2()">mostrar2</button>

        <br><br><br><br><br>

        {{ data.selected }}

        <br><br><br><br><br>

        {{ test }}
    </div>
</template>

<script setup lang="ts">
import { reactive, ref, inject } from "vue";
import { Modal, AutoComplete, AutocompleteElement, navbarKey } from "../../../src/index";

class Example extends AutocompleteElement {
    id_example: number;
    nombre: string;
    nombre2: string;
    dato_adicional: string;

    constructor(
        id_example: number,
        nombre: string,
        nombre2: string,
        dato_adicional: string,
    ) {
        super();
        this.id_example = id_example;
        this.nombre = nombre;
        this.nombre2 = nombre2;
        this.dato_adicional = dato_adicional;
    }

    public get key(): number {
        return this.id_example;
    }
    public get value(): string {
        return this.nombre + " " + this.nombre2;
    }

}

const modal1 = ref<typeof Modal>();
const modal2 = ref<typeof Modal>();
const data = reactive({
    elements: [
        new Example(1, "dato1", "apellido1", "Un dato por aca otro por alla"),
        new Example(2, "dato2", "apellido2", "Un dato por aca otro por alla"),
        new Example(3, "dato3", "apellido3", "Un dato por aca otro por alla"),
        new Example(4, "prueba4", "nombre4", "Un dato por aca otro por alla"),
        new Example(5, "prueba5", "nombre5", "Un dato por aca otro por alla"),
        new Example(6, "prueba6", "nombre6", "Un dato por aca otro por alla"),
        new Example(7, "fede", "rico1", "Un dato por aca otro por alla"),
        new Example(8, "fede", "rico2", "Un dato por aca otro por alla"),
        new Example(9, "fede", "rico3", "Un dato por aca otro por alla"),
        new Example(10, "fedeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeee", "ricooooooooooooooooooooooooooooooooooo4", "Un dato por aca otro por alla")
    ] as Example[],
    selected: null as Example,
    initKey: null as number | string | null,
});

const test = inject(navbarKey);

function mostrar1() {
    modal1.value.show();
}
function ocultar1() {
    modal1.value.hide();
}
function mostrar2() {
    modal2.value.show();
}
</script>

<style></style>
  